<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="80px"
      v-loading="formLoading"
    >
      <el-form-item label="标签名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入标签名称" />
      </el-form-item>
      <el-form-item label="标签分类" prop="category">
        <el-input v-model="formData.category" disabled placeholder="请输入标签分类" />
      </el-form-item>
      <el-form-item label="标签描述" prop="description">
        <el-input v-model="formData.description" type="textarea" :rows="3" placeholder="请输入标签描述" />
      </el-form-item>
      <el-form-item label="标签状态" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio
            v-for="dict in statusOptions"
            :key="dict.value"
            :value="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script setup lang="ts">
import { talentTagApi } from '@/api/menduner/system/talentMap/tag'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const statusOptions = [
	{ label: '启用', value: 'active' },
	{ label: '禁用', value: 'disable' },
]

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formRef = ref() // 表单 Ref
const formData = ref({
  name: undefined,
  description: undefined,
  category: '人才',
  status: 'active'
})
const formRules = reactive({
  status: [{ required: true, message: '标签状态不能为空', trigger: 'blur' }],
  name: [{ required: true, message: '标签中文名称不能为空', trigger: 'blur' }]
})

/** 打开弹窗 */
const open = async (type: string, data?: any) => {
  
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()

  // 修改时，设置数据
  if (data && Object.keys(data).length) {
    formData.value = data
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  await formRef.value.validate()

  const params = {
    status: formData.value.status,
    category: formData.value.category,
    description: formData.value.description,
    name: formData.value.name
  }

  // 提交请求
  formLoading.value = true
  try {
    if (formType.value === 'create') {
      await talentTagApi.createTalentTag(params)
      message.success(t('common.createSuccess'))
    } else {
      await talentTagApi.updateTalentTag(formData.value.id, params)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    name: undefined,
    description: undefined,
    category: '人才',
    status: 'active'
  }
  formRef.value?.resetFields()
}
</script>